#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <stdio.h>
Fl_Menu_Item *G_item = 0;
Fl_Menu_Bar *menubar;
Fl_Menu_Bar *menu2;

// void menu_cb(Fl_Widget* w, void* userdata); // need prototype for ...

// Fl_Menu_Item crash = {"crash", 0, menu_cb, (void *)0x800, FL_MENU_TOGGLE}; // added for testing

void menu_cb(Fl_Widget* w, void* userdata) {
  Fl_Menu_* mw = (Fl_Menu_*)w;
  const Fl_Menu_Item* m = mw->mvalue();
  if (m) printf("%s (userdata=%p)\n", m->label(), m->user_data());
  
  // WHEN ITEM "One" IS PICKED, CALL setonly() FOR THE COLOR ITEM
  
  if ( strcmp(m->label(), "One") == 0 ) {

  if (mw == menubar) printf("menu = menubar\n");
  if (mw == menu2)   printf("menu = menu2\n");
  
  // MAKE IT CRASH !
  
#if 1					// crash the patched version (v2)

  menubar->add(				// this copies the menu() elsewhere
    "crash", 0, menu_cb, (void *)0x800, FL_MENU_TOGGLE);
  printf ("menu item 'crash' added...\n");

#endif					// (crash in v2, fixed in v3)

#if 0					// 1 = "old", 0 = "new" way
    printf("-- old way: G_item->setonly();\n");
    G_item->setonly();		// "old" way
#else
    printf("-- NEW way: mw->setonly(G_item);\n");
    mw->setonly(G_item);	// "new" way
#endif
  }

  menubar->redraw();
  menu2->redraw();
}

int main() {
  
  static Fl_Menu_Item detached[] = {
    {"Bill",    0, menu_cb, (void *)0x701, FL_MENU_TOGGLE},	// added for testing
    {"Joe",    0, menu_cb, (void *)0x702, FL_MENU_RADIO},	// added for testing
    {"Carl",    0, menu_cb, (void *)0x703, FL_MENU_RADIO},	// added for testing
    {0}
  };

  static Fl_Menu_Item menutable[] = {
    {"yes",    0, menu_cb, (void *)0x701, FL_MENU_TOGGLE},	// added for testing
    {"vodka",    0, menu_cb, (void *)0x702, FL_MENU_RADIO},	// added for testing
    {"gin",    0, menu_cb, (void *)0x703, FL_MENU_RADIO},	// added for testing
    {"Red",	0, menu_cb, (void *)0x101, FL_MENU_RADIO},	// group of radio items at /very top/ of menu
    {"Orange",	0, menu_cb, (void *)0x102, FL_MENU_RADIO},
    {"Yellow",	0, menu_cb, (void *)0x103, FL_MENU_RADIO},
    {"Submenu", 0, 0,       0,             FL_SUBMENU},
      {"One",   0, menu_cb, (void *)0x201, FL_MENU_RADIO},	// picking this calls setonly() on one of the colors
      {"Two",   0, menu_cb, (void *)0x202, FL_MENU_RADIO},
      {0},
    {"Detached", 0, 0,       detached,     FL_SUBMENU_POINTER},	// added for testing
      {0}, // NEEDED ???
    {0}
  };
  Fl_Double_Window win(600,200);
  win.begin();
    menubar = new Fl_Menu_Bar(0,0,win.w(),30);
    menubar->menu(&menutable[3]);			// => "Red"
    G_item = (Fl_Menu_Item*)menubar->find_item("Red");	// the color item that will be setonly() when item 'One' is picked
    menu2 = new Fl_Menu_Bar (0,100,win.w(),30);
    menu2->menu(menutable);
  win.end();
  win.show();
  return Fl::run();
}
